package com.hmk.invertedindex;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.ObjectInputStream.GetField;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeMap;


/**
 * COPYRIGHT (C) 2012 Mallika Perepa, Snigdha rao Parvatneni and Chinmayee Annachhatre. All Rights Reserved.
 * CS 267 -02  Homework #1
 * 
 * Inverted Index Printer
 * 
 * @author Mallika Perepa-008335301  Snigdha rao Parvatneni-008648978    Chinmayee Annachhatre-008150285
 * @version 1.0 Sep 11, 2012
 */
public class Index{
	/**
	 * This is the main method of the IndexPrinter class. 
	 * @param args	String[]
	 */
	static TreeMap<String, Word> sortedMap = new TreeMap<String, Index.Word>();
	static List<String> documents = new ArrayList<String>();
	private static int documentCount = 0;
    
	public enum OPERATOR {
		AND("*"), OR("+"), NOT("-");
        
		private String operation;
        
		private OPERATOR(String operation) {
			this.operation = operation;
		}
        
		public String getOperation() {
			return this.operation;
		}
        
		public static OPERATOR getOperator(String operation) {
			OPERATOR[] operations = OPERATOR.values();
			for (OPERATOR operator : operations) {
				if (operator.getOperation().equals(operation)) {
					return operator;
				}
			}
			return null;
		}
	}
    
	
	public static void main (String args[]) {
		if(isOKToProceed(args)){
            try{
            	String queryAlgo = args[2];
            	String query = args[1];
                List<String> contents = readFile(args[0]);
                Map<String, Word> sortedMap = countWords(contents);
                printResult(sortedMap);  
                
                Index index = new Index();
                Index.InvertedIndexADT invertedIndexADT = index.new InvertedIndexADT(); 
                boolean sameFile = true;
                Position position = new Position();
                
                System.out.println("before calling------");
                
                //position = invertedIndexADT.first("good");
                //System.out.println("first doc id----->"+position.getDocId());
                //System.out.println("first doc offset----->"+position.getDocOffset());
                
                //int pos = invertedIndexADT.firstDoc("bad");
                //System.out.println("first doc id----->"+pos);
                
                //position = invertedIndexADT.last("bad");
                //System.out.println("last doc id----->"+position.getDocId());
                //System.out.println("last doc offset----->"+position.getDocOffset());
                
                //int pos = invertedIndexADT.lastDoc("bad");
                //System.out.println("last doc id----->"+pos);
                
                //position.setDocId(0);
                //position.setDocOffset(2);
                //position = invertedIndexADT.next("good",position,sameFile);
                //System.out.println("*****from main()*******");
                //System.out.println("docid in next--->"+position.getDocId());
                //System.out.println("offset in docid in next----->"+position.getDocOffset());
                
                //position.setDocId(0);
                //position.setDocOffset(2);
                //System.out.println("*****from main()*******");
                //int pos = invertedIndexADT.nextDoc("bad", position);
                //System.out.println("next doc id----->"+pos);
                
                //position.setDocId(1);
                //position.setDocOffset(3);
                //System.out.println("*****from main()*******");
                //int pos = invertedIndexADT.prevDoc("bad", position);
                //System.out.println("prev doc id----->"+pos);
                
                //position.setDocId(1);
                //position.setDocOffset(3);
                //position = invertedIndexADT.prev("bad",position,sameFile);
                //System.out.println("*****from main()*******");
                //System.out.println("docid in prev--->"+position.getDocId());
                //System.out.println("offset in docid in prev----->"+position.getDocOffset());
                
                //public Position[] nextCover(String[] terms, Position p)
                invertedIndexADT.calculateDocumentVector();
                
                if("boolean".equalsIgnoreCase(queryAlgo)){
                    invertedIndexADT.rankBoolean(query);
                }else if("cosine".equalsIgnoreCase(queryAlgo)){
                	//TODO : invoke cosine ranking method here
                }
                
            }catch(FileNotFoundException e){
                System.err.println("File not found. Please input a valid file");
            }
		}
	}
    
    /**
     * Checks if the user entered file is valid or not.
     *
     * @param args	String[]
     * @return boolean
     */
    private static boolean isOKToProceed(String args[]){
        boolean value = true;
        if(args.length == 0 || null == args[0]){
			System.err.println("Invalid filename");
			value = false;
		}
        
        return value;
    }
    
    /**
     * process each document and extracts words from it and creates a Word object and stores 
     * the word and document counts.
     *
     * @param contents List<String>
     * @return Map<String, Word>
     */
    private static Map<String, Word> countWords(List<String> contents){
    	//TreeMap<String, Word> sortedMap = new TreeMap<String, Index.Word>();
    	documentCount = contents.size();
        for(String document : contents) {
			document = document.replaceAll("\n"," ");
			String[] wordsToMatch = document.split(" ");
			for (String wordToMatch : wordsToMatch) {
				int docCount = 0;
				for (String content : contents) {
					content = content.replaceAll("\n"," ");
					String[] values = content.split(" ");
					int i = 0;
					int n = -1;
					int pos[] = new int[5000];
					for (String value : values) {
						n++;
						int k = 0;
						if(sortedMap.containsKey(value.trim())){
							Word word = sortedMap.get(value.trim());
							if(wordToMatch.equals(value)){
								pos[i]=n;
								//System.out.println("pos value in if---->"+pos[i]);
								word.getPos().put(docCount, pos);
								i++;
							}
							
							for(int j=0;j<values.length;j++){
								if(value.equals(values[j])){
									k=k+1;
								}
							}
							word.getTermFrequency().put(docCount, k);
							sortedMap.put(value.trim(), word);
						}
						else{
							Word word =new Index().new Word();
							word.setWord(value.trim());
							if(wordToMatch.equals(value)){
								pos[i]=n;
								//System.out.println("pos value in else---->"+pos[i]);
								word.getPos().put(docCount, pos);
								i++;
							}
							
							for(int j=0;j<values.length;j++){
								if(value.equals(values[j])){
									k=k+1;
								}
							}
							word.getTermFrequency().put(docCount, k);
							sortedMap.put(value.trim(), word);
						}
					}
					docCount++;
				}
			}
        }
        return sortedMap;
    }
    
    /**
     * Print the counts in the following format,
     * number of documents, number of total occurances, (document number, number of occurences in that particular document),...
     *
     * @param sortedMap Map<String, Word>
     */
    private static void printResult(Map<String, Word> sortedMap){
        Iterator<String> iter = sortedMap.keySet().iterator();
		while(iter.hasNext()){
			Word value = sortedMap.get(iter.next());
			Map<Integer, int[]> pos = value.getPos();
			Map<Integer, Integer> termFrequency = value.getTermFrequency();
			Iterator<Integer> iter1 = pos.keySet().iterator();
			Iterator<Integer> iter2 = termFrequency.keySet().iterator();
			
			while(iter1.hasNext()){
				int key = iter1.next();
				int key2 = iter2.next();
				int[] value1 = pos.get(key);
				int value2 = termFrequency.get(key2);
				for(int i =0; i < value1.length; i++){
					if(value1[i] == 1){
						//System.out.println("word---->"+value.getWord()+" Document number ---> " + key +"  frequency----->"+value2+ "  Position ----->" + i + ",");
					}
				}
				
			}
		}
    }
	
	/**
	 * This method reads the file, extract the documents from it and store each document in a List object.
     
	 * @param fileName	String
	 * @return	List<String>
	 * @throws FileNotFoundException
	 */
	private static List<String> readFile(String fileName) throws FileNotFoundException{
		List<String> contents = new ArrayList<String>();
		Scanner scanner = new Scanner(new File(fileName));
		scanner.useDelimiter("\n\n");
		while(scanner.hasNext()){
			String text = scanner.next().trim();
			if(null != text && text.length() > 0){
                contents.add(text);	
                documents.add(text);
			}
		}
		return contents;
	}
	class InvertedIndexADT 
	{
		public ArrayList<String> conQueryList = new ArrayList<String>();
		private HashMap<String, HashMap<Integer, Integer>> cacheIndexMap = new HashMap<String, HashMap<Integer, Integer>>();
		private HashMap<Integer, ArrayList<Double>> documentVectorhashMap = new HashMap<Integer, ArrayList<Double>>();
		private HashMap<Integer, ArrayList<Double>> queryVectorhashMap = new HashMap<Integer, ArrayList<Double>>();
		Map<String, Integer> docCountForTerms = new HashMap<String, Integer>();
		private ArrayList<Double> queryVectorList = new ArrayList<Double>();
        
        
		// first doc method implementation
		public int firstDoc(String term){
			System.out.println("****inside first doc****");
			int result = -1;
			if(null!= sortedMap.get(term)){
				Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
				if(!allPositions.isEmpty()){
					result = allPositions.iterator().next();
				}
			}else{
				result = -1;
			}
			return result;	
		}
		//Fist method implementation
		public  Position first(String term){
			System.out.println("inside first method-----");
			//term ="good";
			Position position = new Position();
			if(sortedMap.get(term)!=null){
				int firstDocId = Integer.valueOf(sortedMap.get(term).getPos().keySet().toArray()[0].toString());
			    int FirstOffset = Integer.valueOf(sortedMap.get(term).getPos().get(firstDocId)[0]);	    
			    position.setDocId(firstDocId);
			    position.setDocOffset(FirstOffset);
			}
			else{
				position.setDocId(-1);
			    position.setDocOffset(-1);
			}
			System.out.println("key first------>"+position.getDocId());
			System.out.println("value first------>"+position.getDocOffset());
			return position;
		}
		
		// last Doc method implementation
		public int lastDoc(String term){
			System.out.println("****inside last doc****");
			int result=-1;
			if(null !=sortedMap.get(term) ){
				Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
				if(!allPositions.isEmpty()){
					result = (Integer)allPositions.toArray()[allPositions.size()-1];
				}
			}
			return result;
		}
		//Last method implementation
		public Position last(String term){
			System.out.println("********inside last method*****");
			//term ="good";
			Position position = new Position();
			if(sortedMap.get(term)!=null){
				int keySetlength = sortedMap.get(term).getPos().keySet().toArray().length;
				int lastDocId = Integer.valueOf(sortedMap.get(term).getPos().keySet().toArray()[keySetlength-1].toString());
			    int []offsetArr = sortedMap.get(term).getPos().get(lastDocId);
			    int offsetArrLength = count(offsetArr); 
			    int lastOffset = Integer.valueOf(sortedMap.get(term).getPos().get(lastDocId)[offsetArrLength-1]);
			    position.setDocId(lastDocId);
			    position.setDocOffset(lastOffset);
			}
			else{
				position.setDocId(-1);
			    position.setDocOffset(-1);
			}
			System.out.println("key last------>"+position.getDocId());
			System.out.println("value last------>"+position.getDocOffset());
			return position;
		}
		
		//next doc method implementation
		public int nextDoc(String term, Position currentPosition){
			int current = conQueryList.indexOf(currentPosition.getDocId());
            if(current == -1){
            	if(null != sortedMap.get(term)){
            		Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
                	int currentDocId = currentPosition.getDocId();
                	boolean found = false;
                	while(!found){
                		if(currentDocId == documentCount){
                			return -1;
                		}
                		if(allPositions.contains(Integer.valueOf(++currentDocId))){
                			return currentDocId;
                		}
                	}
            	}
            }
            
            if (current == (conQueryList.size() - 1)){
				System.out.println("inside 2nd if-------");
				return -1;
			}
			System.out.println("next doc id-----"+Integer.valueOf(conQueryList.get(current + 1)));
			return Integer.valueOf(conQueryList.get(current + 1));	
		}
		
		//next doc method for boolean operator NOT implementation
		public int nextDocForNot(String term, Position currentPosition){
			int current = conQueryList.indexOf(currentPosition.getDocId());
            if(current == -1){
            	if(null != sortedMap.get(term)){
            		Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
                	int currentDocId = currentPosition.getDocId();
                	boolean found = false;
                	while(!found){
                		if(currentDocId == documentCount){
                			return -1;
                		}
                		if(!allPositions.contains(Integer.valueOf(++currentDocId))){
                			return currentDocId;
                		}
                	}
            	}
            }
            
            if (current == (conQueryList.size() - 1)){
				System.out.println("inside 2nd if-------");
				return -1;
			}
			System.out.println("next doc id-----"+Integer.valueOf(conQueryList.get(current + 1)));
			return Integer.valueOf(conQueryList.get(current + 1));	
		}
		
		//next method implementation
		public Position next(String term, Position currentPosition, boolean sameFile){
			//System.out.println("*****inside next method*****");
			int low = 0;
			int jump = 0;
			int high = 0;
			int size = 0;
			int docId = -1;
			int docOffset = -1;
			Position position = new Position();
			
			if(sortedMap.get(term)==null){
				//System.out.println("inside condition if---");
				position.setDocId(-1);
				position.setDocOffset(-1);
				return position;
			}
			if (currentPosition != null){
				docId = currentPosition.getDocId();
				docOffset =currentPosition.getDocOffset();
				
				System.out.println("key passed in next------>"+docId);
				System.out.println("value passed in next------>"+docOffset);
			}
			int[] OffsetList = sortedMap.get(term).getPos().get(docId);
			
			if(count(OffsetList) >= 0){
				size = count(OffsetList);
				System.out.println("size of offset list---"+size);
			}
			if ((count(OffsetList) == 0) || OffsetList[size-1] <= docOffset){
				System.out.println("inside 1st if");
				if (sameFile){
					System.out.println("inside same file if");
					position.setDocId(currentPosition.getDocId());
					position.setDocOffset(-1);
					return position;
				}
				int documentId = nextDoc(term, currentPosition); //need to write nextDoc	
				System.out.println("document id------>"+documentId);
				if (documentId < 0){
					position.setDocOffset(-1);
					position.setDocId(currentPosition.getDocId());
					return position;
				} else {
					// set the new position
					
					position.setDocId(documentId);
					position.setDocOffset(-1);
					return next(term, position, sameFile);
				}
			}
			if (OffsetList[0] > docOffset){
				System.out.println("inside 2nd if");
				updateCacheIndex(term, docId, 0); //need to implement
				position.setDocOffset(OffsetList[0]);
				position.setDocId(currentPosition.getDocId());
				return position;
			}
			low = 0;
			if (cacheIndexMap.containsKey(term)){ 
				System.out.println("inside cache if---");//need to implement
				HashMap<Integer, Integer> cache = cacheIndexMap.get(term);
				if (cache.containsKey(docId)) 
				{
					int cacheIndex = cache.get(docId);
					if ((cacheIndex > 0) && (OffsetList[cacheIndex - 1] <= docOffset)) {
						low = cacheIndex - 1;
					}
				}
			}
			System.out.println("outdife all if");
			jump = 1;
			high = low + jump;
			while ((high < size - 1) && (OffsetList[high] <= docOffset)){
				System.out.println("****inside while*****");
				low = high;
				jump = jump * 2;
				high = low + jump;
			}
			if (high > size - 1) {
				System.out.println("-----inside high if----");
				high = size - 1;
			}
			int cacheIndex = binarySearchForNext(term, low, high, currentPosition,OffsetList); 
			System.out.println("cacheIndex in next-----"+cacheIndex);//need to implement
			currentPosition.setDocOffset(OffsetList[cacheIndex]);
			System.out.println("docid-----"+docId);
			System.out.println("offset--"+currentPosition.getDocOffset());
			updateCacheIndex(term, docId, cacheIndex); //need to implement
			position.setDocId(currentPosition.getDocId());
			position.setDocOffset(currentPosition.getDocOffset());
			System.out.println("doc id in currentPosition------>"+position.getDocId());
			System.out.println("doc offset in currentPosition------>"+position.getDocOffset());
			return position;
		}
		
		//counting the length of offset array (to be used in last method)
		public int count(int[] array) {
            int count = 0;
            for(int i : array){
                if(i > 0){
		            count++;
                }
            }
            return count;
        }
		
		//implementation of binary search for next
		public int binarySearchForNext(String term, int low, int high, Position currentPosition, int[] offsetList){
			int mid = 0;
			while ((high - low) > 1){
				mid = (low + high) / 2;
				if (offsetList[mid] <= currentPosition.getDocOffset()){
					low = mid;
				}else{
					high = mid;
				}
			}
			return high;	
		}
		
		//prev doc method	Implementation
		public int prevDoc(String term, Position currentPosition){
			int current = conQueryList.indexOf(currentPosition.getDocId());
            if(current == -1){
            	if(null != sortedMap.get(term)){
            		Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
                	int currentDocId = currentPosition.getDocId();
                	boolean found = false;
                	while(!found){
                		if(currentDocId < 0 ){
                			return -1;
                		}
                		if(allPositions.contains(Integer.valueOf(--currentDocId))){
                			return currentDocId;
                		}
                	}
            	}
            }
            
            if (current == (conQueryList.size() - 1)){
				System.out.println("inside 2nd if-------");
				return -1;
			}
			System.out.println("next doc id-----"+Integer.valueOf(conQueryList.get(current + 1)));
			return Integer.valueOf(conQueryList.get(current + 1));	
		}
		
		//prev doc method for boolean operator NOT implementation
		public int prevDocForNot(String term, Position currentPosition){
			int current = conQueryList.indexOf(currentPosition.getDocId());
            if(current == -1){
            	if(null != sortedMap.get(term)){
            		Set<Integer> allPositions = sortedMap.get(term).getPos().keySet();
                	int currentDocId = currentPosition.getDocId();
                	boolean found = false;
                	while(!found){
                		if(currentDocId < 0 ){
                			return -1;
                		}
                		if(!allPositions.contains(Integer.valueOf(--currentDocId))){
                			return currentDocId;
                		}
                	}
            	}
            }
            
            if (current == (conQueryList.size() - 1)){
				System.out.println("inside 2nd if-------");
				return -1;
			}
			System.out.println("next doc id-----"+Integer.valueOf(conQueryList.get(current + 1)));
			return Integer.valueOf(conQueryList.get(current + 1));	
		}
		
		//implementing prev
		public Position prev(String term, Position currentPosition, boolean sameFile){ 
			//System.out.println("*****inside prev method*****");
			int low = 0;
			int jump = 0;
			int high = 0;
			int size = 0;
			int docId = -2;
			int docOffset = -2;
			Position position = new Position();
			
			if(sortedMap.get(term) == null){
				position.setDocId(docId);
				position.setDocOffset(docOffset);
				return position;
			}
			if (currentPosition != null){
				docId = currentPosition.getDocId();
				docOffset =currentPosition.getDocOffset();
				
				System.out.println("key passed in prev------>"+docId);
				System.out.println("value passed in prev------>"+docOffset);
			}
			int[] OffsetList = sortedMap.get(term).getPos().get(docId);
			if(count(OffsetList) >= 0){
				size = count(OffsetList);
				System.out.println("size of offset list---"+size);
			}
			if ((count(OffsetList) == 0) || OffsetList[0] >= docOffset){
				System.out.println("inside third if----");
				if (sameFile){
					System.out.println("inside same file if----");
					position.setDocId(currentPosition.getDocId());
					position.setDocOffset(-2);
					return position;
				}
				int documentId = prevDoc(term, currentPosition);
				System.out.println("current position after recurssive call----"+currentPosition.getDocOffset());
				System.out.println("documentId-----"+documentId);
				if (documentId == -2){
					System.out.println("inside - 2 document id if----");
					position.setDocId(currentPosition.getDocId());
					position.setDocOffset(-2);
					return position;
				}else{
					int prevousOffsetListSize = 0;
					prevousOffsetListSize = count(sortedMap.get(term).getPos().get(documentId));
					System.out.println("prevousOffsetListSize--"+prevousOffsetListSize);
					int lastValue = sortedMap.get(term).getPos().get(documentId)[prevousOffsetListSize-1];
					System.out.println("last value in prev----"+lastValue);
					position.setDocId(documentId);
					position.setDocOffset(lastValue+1);
					return prev(term, position, sameFile);
				}
			}
			if (OffsetList[size - 1] < docOffset){
				updateCacheIndex(term, docId, size - 1);
				position.setDocOffset(OffsetList[size-1]);
				position.setDocId(currentPosition.getDocId());
				return position;
			}
			high = size - 1;
			if (cacheIndexMap.containsKey(term)){
				HashMap<Integer, Integer> cache = cacheIndexMap.get(term);
				if (cache.containsKey(docId)) {
					int cacheIndex = cache.get(docId);
					if ((cacheIndex < size - 1) && (OffsetList[cacheIndex + 1] >= docOffset)){
						high = cacheIndex + 1;
					}
				}
			}
			jump = 1;
			low = high - jump;
			while ((low > 0) && (OffsetList[low] >= docOffset)){
				high = low;
				jump = jump * 2;
				low = high - jump;
			}
			if (low < 0){
				low = 0;
			}
			int cacheIndex = binarySearchPrev(term, low, high, currentPosition, OffsetList); //to be implemented
			position.setDocOffset(OffsetList[cacheIndex]);
			position.setDocId(currentPosition.getDocId());
			updateCacheIndex(term, docId, cacheIndex);
			System.out.println("doc id in currentPosition------>"+position.getDocId());
			System.out.println("doc offset in currentPosition------>"+position.getDocOffset());
			return position;
		}
		
		//implementing binary search for previous
		public int binarySearchPrev(String term, int low, int high, Position currentPosition, int[] OffsetList){
			int mid = 0;
			while ((high - low) > 1) 
			{
				mid = (low + high) / 2;
				if (OffsetList[mid] < currentPosition.getDocOffset()){
					low = mid;
				}else{
					high = mid;
				}
			}
			return low;
		}
		
		//implementing updateCacheIndex
		public void updateCacheIndex(String term, int docId, int cacheIndex){
			HashMap<Integer, Integer> cacheIndexDocMap = null;
			if (cacheIndexMap.containsKey(term)) 
			{
				// retrieve the cached value
				cacheIndexDocMap = cacheIndexMap.get(term);
				cacheIndexDocMap.put(docId, cacheIndex);
			} else 
			{
				cacheIndexDocMap = new HashMap<Integer, Integer>();
				cacheIndexDocMap.put(docId, cacheIndex);
				cacheIndexMap.put(term, cacheIndexDocMap);
			}
		}
		
		//implementing calculate document vector
		public void calculateDocumentVector(){
			System.out.println("******inside calculate document vector****");
			//Iterator<String> it = conQueryList.iterator();
			int N = documents.size();
			int docNum=-1;
			int termFrequency;
			int Nt;
			double val;
			Double tfValue;
			Double idfValue;
			Double finalValue;
			ArrayList<Double> documentVectorList = new ArrayList<Double>();
			//Map<String, Integer> termDocuments = new HashMap<String, Integer>();
			
			for(String document : documents){
				document = document.replaceAll("\n"," ");
				String[] wordsToMatch = document.split(" ");
				for (String wordToMatch : wordsToMatch){
					int docCount = 0;
					for (String content : documents) {
						content = content.replaceAll("\n"," ");
						if(content.contains(wordToMatch)){
							docCount++;
						}
					}
					docCountForTerms.put(wordToMatch, docCount);
				}
			}
			for(String content : documents){
				docNum++;
				content = content.replaceAll("\n"," ");
				String[] values = content.split(" ");
				for (String value : values){
					//TF calculation
					termFrequency = sortedMap.get(value).getTermFrequency().get(docNum);
					tfValue = (Math.log(termFrequency) / Math.log(2)) + 1;
					//IDF calculation
					Nt = docCountForTerms.get(value);
					val = N/Nt;
					idfValue = (Math.log(val) / Math.log(2));
					finalValue = Round(idfValue * tfValue, 2);
					documentVectorList.add(finalValue);
				}
				documentVectorhashMap.put(docNum, documentVectorList);
				normalizeDocumentVector(documentVectorList, docNum); //to be implemented
			}
		}
		
		//implementing normalize document vector
		public void normalizeDocumentVector(ArrayList<Double> docArrayList, int docId){
			System.out.println("******inside normalize document vector****");
			Iterator<Double> iterator1 = docArrayList.iterator();
			ArrayList<Double> documentArrayList = new ArrayList<Double>();
			double docVectorModulus = 0.0;
			while (iterator1.hasNext()){
				double currentValue = iterator1.next();
				docVectorModulus = docVectorModulus + (currentValue * currentValue);
			}
			docVectorModulus = Math.sqrt(docVectorModulus);
			Iterator<Double> iterator2 = docArrayList.iterator();
			double value, roundModVal= 0.0;
			while (iterator2.hasNext()) {
				value = iterator2.next();
				roundModVal = Round((value / docVectorModulus), 2);
				documentArrayList.add(roundModVal);
				documentVectorhashMap.put(docId, documentArrayList);
			}
		}
		
		//implementing query vector
		public void calculateQueryVector(ArrayList<String> queryTerms){
			int N = documents.size();
			int Nt;
			int docNum = -1;
			int termFrequency;
			double val;
			Double tfValue;
			Double idfValue;
			Double finalValue;
			
			ArrayList<Double> queryVectorList = new ArrayList<Double>();
			for(String content : documents){
				docNum++;
				content = content.replaceAll("\n"," ");
				String[] values = content.split(" ");
				for (String value : values){
					if(queryTerms.contains(value)){
						//TF calculation
						termFrequency = sortedMap.get(value).getTermFrequency().get(docNum);
						tfValue = (Math.log(termFrequency) / Math.log(2)) + 1;
						//IDF calculation
						Nt = docCountForTerms.get(value);
						val = N/Nt;
						idfValue = (Math.log(val) / Math.log(2));
						finalValue = Round(idfValue * tfValue, 2);
						queryVectorList.add(finalValue);
					}else{
						queryVectorList.add(0.00);
					}
				}
				queryVectorhashMap.put(docNum, queryVectorList);
			}
			normalizeQueryVector(queryVectorList); //to be implemented
		}
		
		//implementing normalizeQueryVector
		public void normalizeQueryVector(ArrayList<Double> queryVectorListLocal){
			double sum = 0.0;
			Iterator<Double> iterator1 = queryVectorListLocal.iterator();
			while (iterator1.hasNext()){
				double currentVectorValue = iterator1.next();
				sum = sum + (currentVectorValue * currentVectorValue);
			}
			sum = Math.sqrt(sum);
			Iterator<Double> iterator2 = queryVectorListLocal.iterator();
			double notNormalizedValue, finalVectorValue = 0.0;
			while (iterator2.hasNext()){
				notNormalizedValue = iterator2.next();
				finalVectorValue = Round((notNormalizedValue / sum), 2);
				queryVectorList.add(finalVectorValue);
			}
		}
		
		//implementing rank cosine
		public void rankCosine(){
			int docCount = conQueryList.size();
			int conjQueryDocCount = 0;
			Result result[] = new Result[docCount];
			Iterator<String> iterator = conQueryList.iterator();
			while (iterator.hasNext()){
				String documentId = iterator.next();
				int docId = Integer.parseInt(documentId);
				ArrayList<Double> docVector = documentVectorhashMap.get(docId);
				Iterator<Double> it = docVector.iterator();
				int i = 0;
				double summation = 0.0;
				Double docVectorValue;
				Double queryVectorValue;
				while (it.hasNext()){
					docVectorValue = it.next();
					queryVectorValue = queryVectorList.get(i);
					summation = summation + (docVectorValue * queryVectorValue);
					i++;
				}
				summation = Round(summation, 2);
				// set the cosine score for the document
				result[conjQueryDocCount] = new Result();
				result[conjQueryDocCount].setDocId(docId);
				result[conjQueryDocCount].setScore(summation);
				conjQueryDocCount++;
			}
			Result temp;
			for (int j = docCount; j > 0; j--)
			{
				for (int i = 0; i < j - 1; i++) 
				{
					if (result[i].getScore() > result[i + 1].getScore()) 
					{
						temp = result[i];
						result[i] = result[i + 1];
						result[i + 1] = temp;
					}
				}
			}
			for (int i = docCount - 1; i >= 0; i--){
				System.out.print("(" + result[i].getDocId() + " , "+ result[i].getScore() + ")");
			}
		}
		
		/**
		 * boolean ranking algo
		 * prints the documentIds and rank of the document 
		 * 
		 * @param query String
		 */
		private void rankBoolean(String query){
			List<Expression> expressions = new ArrayList<Expression>();
			List<String> operators = new ArrayList<String>();
			operators.add("+");
			operators.add("-");
			operators.add("*");
            
			String[] queryArr = query.split(" ");
			OPERATOR mainOperator = OPERATOR.getOperator(queryArr[0]);
			if(null == mainOperator){
				mainOperator = OPERATOR.AND;
			}
			Expression expression = null;
			List<String> terms = null;
			for (int i=1; i < queryArr.length; i++) {
                if(null==queryArr[i] || queryArr[i].trim().length()==0){
					continue;
				}
				if(operators.contains(queryArr[i])){
					expression = new Expression();
					expression.setOperator(OPERATOR.getOperator(queryArr[i]));
					terms = new ArrayList<String>();
					expression.setTerms(terms);
					expressions.add(expression);
				}else{
					if(null == expression){
						expression = new Expression();
						terms = new ArrayList<String>();
						expression.setTerms(terms);
						expressions.add(expression);
					}
					terms.add(queryArr[i]);
				}
			}
			
			List<Integer> docIds = new ArrayList<Integer>();
			int u = -1;
			do {
				u = nextSolution(expressions, mainOperator, u);
				if( u > -1){
					docIds.add(u);	
				}
			} while (u > -1);
			
			Collections.sort(docIds);
			for (Integer docId : docIds) {
				DecimalFormat df = new DecimalFormat("#.##");
				double rank = Double.valueOf(df.format(1/((double)docId + 1))).doubleValue();
				System.out.println(docId + "," + rank);
			}
		}
		
		/**
		 * finds out the document based on the docRight and docLeft alorithms.
		 * 
		 * @param expressions	List<Expression>
		 * @param mainOperator	OPERATOR
		 * @param docPosition	int
		 * @return	int
		 */
		private int nextSolution(List<Expression> expressions, OPERATOR mainOperator, int docPosition){
			int v = docRight(expressions, mainOperator, docPosition);
			if(v == -1){
				return -1;
			}
			
			int u = docLeft(expressions, mainOperator, v+1);
			if( u == v){
				return u;
			}
			
			return nextSolution(expressions, mainOperator, v);
		}
		
		/**
		 * looks for the previous document in which the term appears before the given docPosition.
		 * 
		 * @param expressions	List<Expression>
		 * @param mainOperator	OPERATOR
		 * @param docPosition	int
		 * @return	int
		 */
		private int docLeft(List<Expression> expressions, OPERATOR mainOperator, int docPosition){
			List<Integer> finalDocId = new ArrayList<Integer>();
			for (Expression exp : expressions) {
				Position position = new Position();
				position.setDocId(docPosition);
				if(null == exp.getOperator()){
					if(expressions.size() == 1){
						List<Integer> docId = new ArrayList<Integer>();
						for (String term : exp.getTerms()) {
							docId.add(prevDoc(term, position));
						}
						Collections.sort(docId);
						if(mainOperator == OPERATOR.OR){
							finalDocId.add(docId.get(docId.size() - 1));
						}else if(mainOperator == OPERATOR.AND){
							finalDocId.add(docId.get(0));
						}
						finalDocId.add(docId.get(0));
					}else{
						int docId = prevDoc(exp.getTerms().get(0), position);
						finalDocId.add(docId);	
					}
				}else if(exp.getOperator() == OPERATOR.OR){
					List<Integer> docId = new ArrayList<Integer>();
					for (String term : exp.getTerms()) {
						docId.add(prevDoc(term, position));
					}
					Collections.sort(docId);
					finalDocId.add(docId.get(docId.size() - 1));
					//do max
				}else if(exp.getOperator() == OPERATOR.AND){
					List<Integer> docId = new ArrayList<Integer>();
					for (String term : exp.getTerms()) {
						docId.add(prevDoc(term, position));
					}
					Collections.sort(docId);
					finalDocId.add(docId.get(0));
					//do min
				}else if(exp.getOperator() == OPERATOR.NOT){
					int docId = prevDocForNot(exp.getTerms().get(0), position);
					finalDocId.add(docId);
				}
			}
			
			int result = -1;
			Collections.sort(finalDocId);
			if(mainOperator == OPERATOR.OR){
				result = finalDocId.get(finalDocId.size() - 1);
			}else if(mainOperator == OPERATOR.AND){
				result = finalDocId.get(0);
			}
			
			return result;
		}
		
		/**
		 * looks for the next document in which the term appears after the given docPosition.
		 * 
		 * @param expressions	List<Expression>
		 * @param mainOperator	OPERATOR
		 * @param docPosition	int
		 * @return	int
		 */
		private int docRight(List<Expression> expressions, OPERATOR mainOperator, int docPosition){
			List<Integer> finalDocId = new ArrayList<Integer>();
			for (Expression exp : expressions) {
				Position position = new Position();
				position.setDocId(docPosition);
				if(null == exp.getOperator()){
					if(expressions.size() == 1){
						List<Integer> docId = new ArrayList<Integer>();
						for (String term : exp.getTerms()) {
							docId.add(nextDoc(term, position));
						}
						Collections.sort(docId);
						finalDocId.add(docId.get(0));
					}
					int docId = nextDoc(exp.getTerms().get(0), position);
					finalDocId.add(docId);
				}else if(exp.getOperator() == OPERATOR.OR){
					List<Integer> docId = new ArrayList<Integer>();
					for (String term : exp.getTerms()) {
						docId.add(nextDoc(term, position));
					}
					Collections.sort(docId);
					finalDocId.add(docId.get(0));
					//do min
				}else if(exp.getOperator() == OPERATOR.AND){
					List<Integer> docId = new ArrayList<Integer>();
					for (String term : exp.getTerms()) {
						docId.add(nextDoc(term, position));
					}
					Collections.sort(docId);
					finalDocId.add(docId.get(docId.size() - 1));
					//do max
				}else if(exp.getOperator() == OPERATOR.NOT){
					int docId = nextDocForNot(exp.getTerms().get(0), position);
					finalDocId.add(docId);
				}
			}
			
			int result = -1;
			Collections.sort(finalDocId);
			if(mainOperator == OPERATOR.AND){
				result = finalDocId.get(finalDocId.size() - 1);
			}else if(mainOperator == OPERATOR.OR){
				result = finalDocId.get(0);
			}
			
			return result;
		}
		
		/**
		 * Express object which holds the query operator and the query terms.
		 *
		 */
		private class Expression{
			private OPERATOR operator;
			private List<String> terms;
			
			public OPERATOR getOperator() {
				return operator;
			}
			public void setOperator(OPERATOR operator) {
				this.operator = operator;
			}
			public List<String> getTerms() {
				return terms;
			}
			public void setTerms(List<String> terms) {
				this.terms = terms;
			}
		}
		
		//implementing round function
		public double Round(double numberToBeRounded, int decimalPlaces) 
		{
			double temp = Math.pow(10.0, decimalPlaces);
			return Math.round(numberToBeRounded * temp) / temp;
		}
		
		//implementing method for conjunctive query
		public ArrayList<String> conjunctiveQuery(int documentCount,String queryVector){
			queryVector = queryVector.toLowerCase();
			String queryTerms[] = queryVector.split(" ");
			String minTerm = queryTerms[0];
			ArrayList<String> docIdList = new ArrayList<String>();
			if(queryTerms.length > 1){
				int size = documentCount;
				for(String term : queryTerms){	
					if(sortedMap.get(term) != null){
						int termFrequency = sortedMap.get(term).getPos().keySet().size();
						if(termFrequency < size){
							size = termFrequency;
							minTerm = term;
						}
					} 
				}
				Position p = new Position();
				p.setDocId(-1);
				p.setDocOffset(-1);
				int docID = nextDoc(minTerm,p);
				while(docID >= 0){
					Integer integerDocId = new Integer(docID);
					docIdList.add(integerDocId.toString());
					p.setDocId(docID);
					p.setDocOffset(-1);
					docID = nextDoc(minTerm,p);
				}
				ArrayList<String> newDocIdList = new ArrayList<String>();
				for(int i=0; i<queryTerms.length; i++){	
					if(!queryTerms[i].equalsIgnoreCase(minTerm)){
						Iterator<String> it = docIdList.iterator();
						newDocIdList = new ArrayList<String>();
						while(it.hasNext()){
							String documentID = (String)it.next();{
								if((sortedMap.get(queryTerms[i]) != null) && (sortedMap.get(queryTerms[i]).getPos().keySet().contains(documentID))){
									newDocIdList.add(documentID);
								}
							}	
						}
						docIdList = newDocIdList;
					}
				}	
			}else{
				Position p = new Position();
				p.setDocId(-1);
				p.setDocOffset(-1);
				int docID = nextDoc(queryTerms[0],p);
				while(docID >= 0){	
					Integer integerDocId = new Integer(docID);
					docIdList.add(integerDocId.toString());
					p = new Position();
					p.setDocId(docID);
					p.setDocOffset(-1);
					docID = nextDoc(queryTerms[0],p);
				}
			}	
			return docIdList;
		}
		
		// implement calculate ranking method
		public void calculateRanking(String query, String rankingAlgorithm){
			conQueryList = conjunctiveQuery(documents.size(),query);
			if (conQueryList.size() != 0){
				calculateDocumentVector();
				ArrayList<String> queryArrayList = new ArrayList<String>();
				String[] queryTerms = query.split(" ");
				for (String term : queryTerms){
					queryArrayList.add(term);
				}
				calculateQueryVector(queryArrayList);
				if (rankingAlgorithm != null){
					rankCosine();
				}
			}else{
				System.out.println("No document in the file matched for user's query");
			}
		}
        //end of InvertedIndexADT class	
	}
	
    /**
     * This is a inner class to hold the Word data.
     *
     */
	private class Word{
		private String word;
		private Map<Integer, int[]> pos = new HashMap<Integer, int[]>();
		private Map<Integer, Integer> termFrequency = new HashMap<Integer, Integer>();
		
		public String getWord() {
			return word;
		}
		public void setWord(String word) {
			this.word = word;
		}
		public Map<Integer, int[]> getPos() {
			return pos;
		}
		public void setPos(Map<Integer, int[]> pos) {
			this.pos = pos;
		}
		public Map<Integer, Integer> getTermFrequency() {
			return termFrequency;
		}
		public void setTermFrequency(Map<Integer, Integer> termFrequency) {
			this.termFrequency = termFrequency;
		}	
	}
	
	static class Position{
		private int docId;
		private int docOffset;
		
		public int getDocId() {
			return docId;
		}
		public void setDocId(int docId) {
			this.docId = docId;
		}
		public int getDocOffset() {
			return docOffset;
		}
		public void setDocOffset(int docOffset) {
			this.docOffset = docOffset;
		}
	}
	
	class Result{
		private int docId;
		private double score;
		public int getDocId() {
			return docId;
		}
		public void setDocId(int docId) {
			this.docId = docId;
		}
		public double getScore() {
			return score;
		}
		public void setScore(double score) {
			this.score = score;
		}
	}
}
